close all



%Get image
orig = double(imread('orig.png'))/255.0;

%Get filter
sz = 5;
h = fspecial('disk',sz);


%Get blurry image using a convolution, e.g. "conv2"
blur1 = zeros(size(orig)); % ADD CODE HERE

%Get blurry image using multiplication in the Fourier domain, using e.g. fft2
blur2 = zeros(size(orig)); % ADD CODE HERE


%Compare results
display('Difference: ' + string( sum(sum(abs( blur1-blur2 ))) )) %Should be at most of the order 1e-10


%Set noise
sig = [5.0,4.8,4.6,4.4,4.2,4.0,3.5];


%Test different noise levels
for i = 1:size(sig,2)

sigma = 10^(-sig(i));

blurn = blur1 + sigma*randn(size(blur1));

recon = zeros(size(blurn)); % ADD CODE HERE

res = cat(2,blurn,recon);
figure('Name','Sigma: 1e-' + string(sig(i)) ) 
imshow(res)

end

%Bonus: Can you come up with a better solution to obtain "recon"?
